=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://www.nntb.no/~dreibh/fractalgenerator/index.html	download/fractgen-(.*)\.tar\.xz
